import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    int score=0;
    int bisonlolos=0;
    int level=1;
    boolean playGame=false;
    
    
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 525, 1);
        prepare();
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        cowboy cowboy = new cowboy();
        addObject(cowboy,73,429);
        cowboy.setLocation(79,286);
        bersih bersih = new bersih();
        addObject(bersih,0,0);
        bersih.setLocation(0, 320);
        bersih2 bersih2 = new bersih2();
        addObject(bersih2,794, 320);
        bersih2.setLocation(798, 320);
       
        //buat 3 bison 
        for (int x=0; x<3; x++) { 
            buatBison();
        }

        //buat 3 kaktus 
        for (int x=0; x<3; x++) { 
            buatKaktus();
        }

        displayScore();
        showText("Bison Lolos = 0", 800 - 100, 70);
        
        //Tampilkan halaman welcome depan
        bgdepan bgdepan1 = new bgdepan();
        addObject(bgdepan1,0,0);
        bgdepan1.setLocation(400,262);
        
        //Tampilkan BOS Gangster sementara saja
        //munculBos();
    }
    
    
    public void displayScore()
    {
        showText("Score = " + score, 800 - 80, 30);
        showText("Level = " + level, 800 - 80, 50);
    }
    
    public void tambahScore(int points){
        score = score + points;
        displayScore(); 
    }
    
    public void kurangScore(int points){
        if (score >= 10) 
           score = score - points;
        else score = 0;
        displayScore(); 
    }
    
    public void cekBisonlolos(){
        bisonlolos = bisonlolos + 1;
        showText("Bison Lolos = " + bisonlolos, 800 - 100, 70); 
        if (bisonlolos >= 5) {
            showText("GAME OVER", 340, 250);
            Greenfoot.playSound("gameover.mp3");
            Greenfoot.stop();
        }
    }
   
    
    public void buatBison()
    {
        int acakX=0, acakY=0;
        acakX=Greenfoot.getRandomNumber(80) + 670;
        acakY=Greenfoot.getRandomNumber(400) + 125;
        bison bison2 = new bison();
        addObject(bison2, acakX, acakY);
        bison2.setLocation(acakX, acakY);
    }
    
    public void buatKaktus()
    {
        int acakX=0, acakY=0;
        acakX=Greenfoot.getRandomNumber(800);
        acakY=Greenfoot.getRandomNumber(400) + 125;
        kaktus kaktus2 = new kaktus();
        addObject(kaktus2, acakX, acakY);
        kaktus2.setLocation(acakX, acakY);
    }
    
    public void munculCoin() 
    {
        //tampilkan coin jika point kelipatan 200 
        if (score % 200==0) 
            {
              int acakX=0, acakY=0;
              tambahScore(10);
              acakX=Greenfoot.getRandomNumber(800);
              acakY=Greenfoot.getRandomNumber(400) + 125;
              coin coin1 = new coin();
              addObject(coin1, acakX, acakY);
              coin1.setLocation(acakX, acakY);
            }
    }
    
    public void munculBos() 
    {
       int acakX=0, acakY=0;
        acakX=Greenfoot.getRandomNumber(80) + 670;
        acakY=Greenfoot.getRandomNumber(400) + 125;
        gangster gangster1 = new gangster();
        addObject(gangster1, acakX, acakY);
        gangster1.setLocation(acakX, acakY); 
    }
    
    public void naikLevel() 
    {
        if (score % 1000 == 0)
        {
            tambahScore(10);
            level = level + 1;
            //Tambahkan tingkat kesulitan
            buatBison();
            buatKaktus();
            displayScore();
            Greenfoot.playSound("levelUp.wav");
            //Tampilkan BOS Gangster
            munculBos();
        }
    }
    
    public void saatnyaPlayGame()
      {
        if (playGame == false)
          playGame = true;
      }
}
